SystemOrganization addCategory: #Roassal2Spec!
SystemOrganization addCategory: #'Roassal2Spec-Core'!
SystemOrganization addCategory: #'Roassal2Spec-Example'!

!TRMouseClick methodsFor: '*Roassal2Spec' stamp: 'BenjaminVanRyseghem 1/22/2014 15:30'!
isMouse

	^ true! !

RTView subclass: #RTViewForSpec
	instanceVariableNames: 'lastEvent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2Spec-Core'!

!RTViewForSpec commentStamp: 'BenjaminVanRyseghem 1/22/2014 10:52' prior: 0!
I am a special view used to record registered announcement to propagate them outside of the view to other Spec models!

!RTViewForSpec methodsFor: 'adding' stamp: 'AlexandreBergel 10/6/2014 10:50'!
addElement: anElement

	super addElement: anElement.
	
	anElement announcer subscriptions 
		subscriptionsDo: [ :reg | 
			anElement 
				when: reg announcementClass
				do: [ :ann | lastEvent value: ann ] ]! !

!RTViewForSpec methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 1/22/2014 09:33'!
initialize

	super initialize.

	lastEvent := nil asValueHolder.! !

!RTViewForSpec methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/22/2014 09:34'!
lastEvent
	^ lastEvent value! !

!RTViewForSpec methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/22/2014 09:34'!
lastEvent: anObject
	lastEvent value: anObject! !

!RTViewForSpec methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/22/2014 15:03'!
lastEventSubscriptionsDo: aBlock

	lastEvent announcer subscriptions subscriptionsDo: aBlock! !

!RTViewForSpec methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 1/22/2014 09:35'!
whenLastEventChangedDo: aBlock

	lastEvent whenChangedDo: aBlock! !

AbstractMorphicAdapter subclass: #MorphicRoassalAdapter
	instanceVariableNames: 'view canvas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2Spec-Core'!

!MorphicRoassalAdapter commentStamp: '<historical>' prior: 0!
I am bridging RoassalModel and RTView!

!MorphicRoassalAdapter methodsFor: 'private' stamp: 'BenjaminVanRyseghem 1/22/2014 15:07'!
adapt: aComposableModel

	super adapt: aComposableModel.
	
	view := widget.
	canvas := view setUpCanvas.
	widget := canvas buildMorph.
	widget
		setProperty: #model toValue: self;
		hResizing: #spaceFill;
		vResizing: #spaceFill.
	
	self basicApplyScript
	! !

!MorphicRoassalAdapter methodsFor: 'private' stamp: 'BenjaminVanRyseghem 1/22/2014 14:44'!
applyScript

	self freeCanvas.
	self basicApplyScript! !

!MorphicRoassalAdapter methodsFor: 'private' stamp: 'BenjaminVanRyseghem 1/22/2014 14:44'!
basicApplyScript

	self model script 
		cull: view 
		cull: canvas.
		
	self widgetDo: [ :w | w startStepping ]! !

!MorphicRoassalAdapter methodsFor: 'private' stamp: 'AlexandreBergel 12/6/2015 21:23'!
buildWidget
	self flag: 'Remove whenLastEventChangedDo:'.
	^ RTViewForSpec new
		whenLastEventChangedDo: self whenLastEventChangedBlock;
		yourself! !

!MorphicRoassalAdapter methodsFor: 'private' stamp: 'johanfabry 7/12/2015 10:12'!
freeCanvas

	view := self buildWidget.
	canvas := view setUpCanvas.
	widget extent: canvas extent.

	widget canvas: canvas.! !

!MorphicRoassalAdapter methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/22/2014 14:13'!
view

	^ view! !

!MorphicRoassalAdapter methodsFor: 'protocol' stamp: 'johanfabry 7/12/2015 10:16'!
whenLastEventChangedBlock
	self flag: 'Remove me'.
	"^ [ :evt | self model lastEvent: evt ]"
	^ [ :evt | ]! !

!SubscriptionRegistry methodsFor: '*Roassal2Spec' stamp: 'BenjaminVanRyseghem 1/22/2014 10:04'!
subscriptionsDo: aBlock
	| copy |
	
	self protected: [ copy := subscriptions copy ].
	
	copy do: aBlock! !

AbstractWidgetPresenter subclass: #RoassalModel
	instanceVariableNames: 'script lastEvent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2Spec-Core'!

!RoassalModel commentStamp: 'johanfabry 7/24/2015 08:27' prior: 0!
I am a Spec model to embed Roassal2 visualizations. See the SpecEasel class for an example use.!

!RoassalModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 1/6/2014 13:00'!
defaultSpec
	<spec>
	
	^ #(MorphicRoassalAdapter
		adapt: #(model))! !

!RoassalModel methodsFor: 'initialize' stamp: 'johanfabry 7/12/2015 07:19'!
initialize

	super initialize.

	script := [ :v :canvas | ] asValueHolder.
	script whenChangedDo: [ :s | self refresh ].
	self flag: 'Remove lastEvent'.
	lastEvent := nil asValueHolder.! !

!RoassalModel methodsFor: 'accessing' stamp: 'johanfabry 7/12/2015 07:17'!
lastEvent
	self deprecated: 'This feature is no longer supported.'.
	^ lastEvent value! !

!RoassalModel methodsFor: 'accessing' stamp: 'johanfabry 7/12/2015 07:17'!
lastEvent: aBlock
	self deprecated: 'This feature is no longer supported.'.
	lastEvent value: aBlock! !

!RoassalModel methodsFor: 'api' stamp: 'johanfabry 7/22/2015 19:31'!
refresh
	"Rerun the script"
	self changed: #applyScript with: #()! !

!RoassalModel methodsFor: 'api' stamp: 'johanfabry 7/22/2015 19:33'!
script
	"Returns the block that draws the visualization."
	^ script value! !

!RoassalModel methodsFor: 'api' stamp: 'johanfabry 7/24/2015 11:53'!
script: aBlock
	"Set the block that draws the visualization.
	 It should take two arguments: the view and the canvas"
	script value: aBlock! !

!RoassalModel methodsFor: 'api-events' stamp: 'BenjaminVanRyseghem 1/22/2014 15:16'!
whenLastEventChangedDo: aBlock

	lastEvent whenChangedDo: aBlock! !

ComposableModel subclass: #RoassalAndSpecExample
	instanceVariableNames: 'label diagram button1 button2 view'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2Spec-Example'!

!RoassalAndSpecExample class methodsFor: 'specs' stamp: 'AlexandreBergel 12/4/2015 18:59'!
defaultSpec 
	<spec: #default>
	^ SpecLayout composed
		newColumn: [ :tcol|
					tcol
						add: #label height: self toolbarHeight;
						add: #button1 height: self toolbarHeight;
						add: #button2 height: self toolbarHeight;
						add: #diagram ]! !

!RoassalAndSpecExample class methodsFor: 'instance creation' stamp: 'AlexandreBergel 12/4/2015 19:32'!
open
	<script>
	"
	RoassalAndSpecExample open
	"
	^ self new openWithSpec! !

!RoassalAndSpecExample methodsFor: 'accessing' stamp: 'AlexandreBergel 12/4/2015 18:57'!
button1
	^ button1! !

!RoassalAndSpecExample methodsFor: 'accessing' stamp: 'AlexandreBergel 12/4/2015 18:57'!
button1: anObject
	button1 := anObject! !

!RoassalAndSpecExample methodsFor: 'accessing' stamp: 'AlexandreBergel 12/4/2015 18:57'!
button2
	^ button2! !

!RoassalAndSpecExample methodsFor: 'accessing' stamp: 'AlexandreBergel 12/4/2015 18:57'!
button2: anObject
	button2 := anObject! !

!RoassalAndSpecExample methodsFor: 'accessing' stamp: 'AlexandreBergel 12/4/2015 18:57'!
diagram
	^ diagram! !

!RoassalAndSpecExample methodsFor: 'accessing' stamp: 'AlexandreBergel 12/4/2015 18:57'!
diagram: anObject
	diagram := anObject! !

!RoassalAndSpecExample methodsFor: 'initialization' stamp: 'AlexandreBergel 12/4/2015 19:32'!
initializePresenter

	"This causes the diagram's script to be executed again."
	button1 action: [ view add: (RTEllipse new size: 40 atRandom) element. view signalUpdate ].
	button2 action: [ RTFlowLayout on: view elements. view signalUpdate ]! !

!RoassalAndSpecExample methodsFor: 'initialization' stamp: 'AlexandreBergel 6/20/2018 13:07'!
initializeWidgets

	label := self newLabel.
	label label: 'Simple example of combining Roassal and Spec' .

	button1 := self newButton.
	button1 label: 'Add Circle'.

	button2 := self newButton.
	button2 label: 'Layout!!'.

	
	diagram := self instantiate: RoassalModel.	
	diagram script: [ :aView :canvas | self view: aView. aView @ RTDraggableView. 
								aView canvas addMenu: 'In' callback: [ RTZoomInMove on: aView ].
								aView canvas addMenu: 'Out' callback: [ RTZoomOutMove on: aView ].
								aView canvas addMenu: 'Center' callback: [ aView canvas focusOnCenterScaled ].
 						].
"	diagram script: [ :view :canvas | self textAsCode value: view value: canvas ]"! !

!RoassalAndSpecExample methodsFor: 'accessing' stamp: 'AlexandreBergel 12/4/2015 18:57'!
label
	^ label! !

!RoassalAndSpecExample methodsFor: 'accessing' stamp: 'AlexandreBergel 12/6/2015 21:15'!
label: aString
	label := aString! !

!RoassalAndSpecExample methodsFor: 'accessing' stamp: 'AlexandreBergel 12/4/2015 19:31'!
view
	^ view! !

!RoassalAndSpecExample methodsFor: 'accessing' stamp: 'AlexandreBergel 12/6/2015 21:15'!
view: aRoassalView
	view := aRoassalView! !

!TREvent methodsFor: '*Roassal2Spec' stamp: 'BenjaminVanRyseghem 1/22/2014 15:29'!
isMouse

	^ false! !

ComposablePresenter subclass: #SpecEasel
	instanceVariableNames: 'label text diagram button'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2Spec-Example'!

!SpecEasel commentStamp: 'johanfabry 7/12/2015 11:31' prior: 0!
I am a demo of how to use the Spec Roassal Integration. I implement the behavior that was originally present in the Roassal Easel.

To run, do-it of the following: 
SpecEasel  new openWithSpec!

!SpecEasel class methodsFor: 'specs' stamp: 'johanfabry 7/24/2015 11:49'!
defaultSpec 
	<spec: #default>
	^ SpecLayout composed
		newColumn: [:tcol|
			tcol newRow: [:trow|
				trow newColumn: [:left |
					left
						add: #label height: self toolbarHeight;
						add: #text ;
						add: #button height: self toolbarHeight ] width: 400.
				trow add: #diagram]].! !

!SpecEasel methodsFor: 'accessing' stamp: 'johanfabry 7/12/2015 11:41'!
button
	^ button! !

!SpecEasel methodsFor: 'accessing' stamp: 'johanfabry 7/12/2015 11:41'!
button: anObject
	button := anObject! !

!SpecEasel methodsFor: 'accessing' stamp: 'johanfabry 7/12/2015 11:16'!
diagram
	^ diagram! !

!SpecEasel methodsFor: 'accessing' stamp: 'johanfabry 7/12/2015 11:16'!
diagram: anObject
	diagram := anObject! !

!SpecEasel methodsFor: 'accessing' stamp: 'johanfabry 7/24/2015 08:30'!
extent
	^800@600! !

!SpecEasel methodsFor: 'initialization' stamp: 'johanfabry 7/24/2015 08:40'!
initializePresenter

	"This causes the diagram's script to be executed again."
	button action: [ diagram refresh ]! !

!SpecEasel methodsFor: 'initialization' stamp: 'johanfabry 7/24/2015 11:49'!
initializeWidgets

	label := self newLabel.
	label label: 'Enter code below. Both view and canvas are accessible' .

	text := self newText.
	text text: self startText.
	text autoAccept: true.

	button := self newButton.
	button label: 'Draw this!!'.

	diagram := self instantiate: RoassalModel.	
	"This is the code for the Roassal view.
	The block takes both a view and a canvas."
	diagram script: [ :view :canvas | self textAsCode value: view value: canvas ]! !

!SpecEasel methodsFor: 'accessing' stamp: 'johanfabry 7/24/2015 11:44'!
label
	^ label! !

!SpecEasel methodsFor: 'accessing' stamp: 'johanfabry 7/24/2015 11:44'!
label: anObject
	label := anObject! !

!SpecEasel methodsFor: 'accessing' stamp: 'johanfabry 7/27/2015 12:33'!
startText
	^
'|els|
	els := RTEllipse new
				size: #yourself;
				elementsOn: ((1 to: 20) collect: [ :v | 50 atRandom ]).
	view addAll: els.
	RTCellLayout new lineItemsCount: 5; on: view elements.
	
	view @ RTDraggableView.
	canvas camera focusOnCenterScaled: 300.
'  asText! !

!SpecEasel methodsFor: 'accessing' stamp: 'johanfabry 7/12/2015 11:16'!
text
	^ text! !

!SpecEasel methodsFor: 'accessing' stamp: 'johanfabry 7/12/2015 11:16'!
text: anObject
	text := anObject! !

!SpecEasel methodsFor: 'drawing' stamp: 'AutoDeprecationRefactoring 7/13/2018 18:19'!
textAsCode
	"This could be made more clever with regard to compilation and runtime errors. But for this simple example it should suffice."

	^ OpalCompiler new
		source: '[:view :canvas | ' , self text getText asString , ']';
		logged: false;
		evaluate! !

!SpecEasel methodsFor: 'accessing' stamp: 'johanfabry 7/12/2015 11:45'!
title
	^ 	'The Spec Roassal Canvas'! !
